GNU logs - #23486, boring messages


Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#23486: 25.0.93; Modules: features missing from make_function
Resent-From: Philipp Stephani <p.stephani2@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Mon, 09 May 2016 16:39:02 +0000
Resent-Message-ID: <handler.23486.B.146281189924474 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: report 23486
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: 23486 <at> debbugs.gnu.org
X-Debbugs-Original-To: bug-gnu-emacs@HIDDEN
Received: via spool by submit <at> debbugs.gnu.org id=B.146281189924474
          (code B ref -1); Mon, 09 May 2016 16:39:02 +0000
Received: (at submit) by debbugs.gnu.org; 9 May 2016 16:38:19 +0000
Received: from localhost ([127.0.0.1]:44567 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1azoCI-0006Mg-LR
	for submit <at> debbugs.gnu.org; Mon, 09 May 2016 12:38:18 -0400
Received: from eggs.gnu.org ([208.118.235.92]:56346)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <p.stephani2@HIDDEN>) id 1azoCH-0006MT-L9
 for submit <at> debbugs.gnu.org; Mon, 09 May 2016 12:38:18 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1azoCB-00051b-2g
 for submit <at> debbugs.gnu.org; Mon, 09 May 2016 12:38:12 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: *
X-Spam-Status: No, score=1.1 required=5.0 tests=BAYES_50,
 FREEMAIL_ENVFROM_END_DIGIT,FREEMAIL_FROM,T_DKIM_INVALID autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:38718)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1azoCA-00051P-WD
 for submit <at> debbugs.gnu.org; Mon, 09 May 2016 12:38:11 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:47238)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1azoC9-0002JO-7h
 for bug-gnu-emacs@HIDDEN; Mon, 09 May 2016 12:38:10 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1azoC6-0004vm-Pf
 for bug-gnu-emacs@HIDDEN; Mon, 09 May 2016 12:38:08 -0400
Received: from mail-wm0-x22d.google.com ([2a00:1450:400c:c09::22d]:35915)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1azoC6-0004vU-FG
 for bug-gnu-emacs@HIDDEN; Mon, 09 May 2016 12:38:06 -0400
Received: by mail-wm0-x22d.google.com with SMTP id n129so145503109wmn.1
 for <bug-gnu-emacs@HIDDEN>; Mon, 09 May 2016 09:38:06 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=from:to:subject:date:message-id:mime-version
 :content-transfer-encoding;
 bh=1mrf/U17t2H2yydVbUY3PMnMyZar09j5PmyuNZBB2bc=;
 b=Gx2VKlSXXtjmkzDgiejPeABVegxzFGsBVOcXZfAuzELQX34AvbmSxik3FDDjfe8Ss9
 jBrs8o1+75U8YKG9EdxW07CclH20zQMcpOu2U6o6TzbFdKcGQozkWW+TMnDv4MaCI/sk
 32mTDuoeHIGxYtmHduGaKHJ2bg+oMBUyJt7d9DtrrdB5gdbtpYd7sXZcLNJpnYk+g83g
 ll2MbCU54vyj5v9YRpIXnEfIcKI/p/mOgIzy+43o+PoIIEBBvUUCORyxcvPXb+btm7+u
 c1ro0P/m5IIF8aJYHxxBGprXR3vZmgcuOvfb73Bav3CTb9hCZ5bAh/xKhb9adMv3JBXE
 /kUw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version
 :content-transfer-encoding;
 bh=1mrf/U17t2H2yydVbUY3PMnMyZar09j5PmyuNZBB2bc=;
 b=Rhq3PFwU57rpSUalzNpI5hSZC8C/zOkWu5D97Y6v26P8YUEZFRC7ekcQ2FZtWIilm+
 +iB7u4NhzDU1K+XAzK/084fizr3D6YH6u7gWr38HXspf8y3z/dMR1oHPwCwg/Q/3P2Ws
 rnjGt4hgE/MBqb1eo0EtQpJ1mWCbrvgI24y09CZsWJ09csID+fbhwz3yek5iTW3ClBSe
 ROh+P6mIaA9TgmQkzgZln03gGHEUvtyxfNxqPQUtKswFk8NJXpQOjIZ8E61UzQy7fTXU
 SkIq4QcqMcrAsA0lIopR7BtLjdwsp6mDqncqygOm8gazsmjPLel9m3LZa/+TaNGJ4nK6
 EHNg==
X-Gm-Message-State: AOPr4FVOq0xIf6/ekB2snXx1W9pxaRSBkxSi10ebr5FKNPibkaYQ+WOGdoF+phjNurqhiw==
X-Received: by 10.28.137.210 with SMTP id l201mr7539262wmd.31.1462811885435;
 Mon, 09 May 2016 09:38:05 -0700 (PDT)
Received: from a.muc.corp.google.com ([2a00:79e0:15:4:19a2:1c69:3bad:ed48])
 by smtp.gmail.com with ESMTPSA id n66sm25615690wmn.7.2016.05.09.09.38.04
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1_2 cipher=AES128-SHA bits=128/128);
 Mon, 09 May 2016 09:38:04 -0700 (PDT)
From: Philipp Stephani <p.stephani2@HIDDEN>
Date: Mon, 09 May 2016 18:37:58 +0200
Message-ID: <wvr4a8jzchll.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -3.8 (---)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.8 (---)


emacs_env::make_function lacks the following features supported by
`defun':

1. Functions with both optional and rest arguments.
2. Specification of parameter names.
3. Integration with `help-function-arglist'.
4. Specification of interactive forms.
5. Specification of declare forms.
6. Docstrings containing null or non-Unicode characters.

(6) is probably rather unimportant.  (5) is probably not implementable
(would require wrapping `defun', not `lambda').  (1)=E2=80=93(4) are more s=
evere
and quite limit the usefulness of make_function right now; for a
truly generic `defun'-like construct one currently has to eval a `defun'
form wrapping another function.

To solve (1)=E2=80=93(3), I'd propose replacing the "arity" arguments with a
true arglist specification.  This could either be at the C level, e.g.

    ptrdiff_t num_mandatory_args, char** mandatory_arg_names,
    ptrdiff_t num_optional_args, char** optional_arg_names,
    char* rest_arg_name

or by requiring to pass a Lisp argument list.

To solve (4) I'd propose to pass another value for the interactive form,
probably as emacs_value* (to support non-interactive functions).

As an alternative, if people feel this would require too many
parameters, I'd propose reverting the change that adds the documentation
string.  A docstring without arglist is not very useful.  We could also
remove the arity parameters and have the C function check the arity
itself.



In GNU Emacs 25.0.93.5 (x86_64-unknown-linux-gnu, GTK+ Version 3.10.8)
 of 2016-04-24 built on localhost
Repository revision: 0cd2e923dba8d8c7128b0c084ce6af22069e8db5
Windowing system distributor 'The X.Org Foundation', version 11.0.11501000
System Description:	Ubuntu 14.04 LTS

Configured using:
 'configure --with-modules'

Configured features:
XPM JPEG TIFF GIF PNG SOUND GSETTINGS NOTIFY FREETYPE XFT ZLIB
TOOLKIT_SCROLL_BARS GTK3 X11 MODULES

Important settings:
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Lisp Interaction

Minor modes in effect:
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent messages:
For information about GNU Emacs and the GNU system, type C-h C-a.

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message dired format-spec rfc822 mml
mml-sec password-cache epg epg-config gnus-util mm-decode mm-bodies
mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader sendmail
rfc2047 rfc2045 ietf-drums mm-util help-fns help-mode easymenu
cl-loaddefs pcase cl-lib mail-prsvr mail-utils time-date mule-util
tooltip eldoc electric uniquify ediff-hook vc-hooks lisp-float-type
mwheel x-win term/common-win x-dnd tool-bar dnd fontset image regexp-opt
fringe tabulated-list newcomment elisp-mode lisp-mode prog-mode register
page menu-bar rfn-eshadow timer select scroll-bar mouse jit-lock
font-lock syntax facemenu font-core frame cl-generic cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese eucjp-ms cp51932 hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese charscript case-table epa-hook
jka-cmpr-hook help simple abbrev minibuffer cl-preloaded nadvice
loaddefs button faces cus-face macroexp files text-properties overlay
sha1 md5 base64 format env code-pages mule custom widget
hashtable-print-readable backquote inotify dynamic-setting
system-font-setting font-render-setting move-toolbar gtk x-toolkit x
multi-tty make-network-process emacs)

Memory information:
((conses 16 88004 8077)
 (symbols 48 19855 0)
 (miscs 40 325 197)
 (strings 32 14723 4466)
 (string-bytes 1 436825)
 (vectors 16 12084)
 (vector-slots 8 438946 3946)
 (floats 8 164 12)
 (intervals 56 202 0)
 (buffers 976 12)
 (heap 1024 36386 931))

--=20
Google Germany GmbH
Erika-Mann-Stra=C3=9Fe 33
80636 M=C3=BCnchen

Registergericht und -nummer: Hamburg, HRB 86891
Sitz der Gesellschaft: Hamburg
Gesch=C3=A4ftsf=C3=BChrer: Matthew Scott Sucherman, Paul Terence Manicle

Diese E-Mail ist vertraulich.  Wenn Sie nicht der richtige Adressat sind,
leiten Sie diese bitte nicht weiter, informieren Sie den Absender und l=C3=
=B6schen
Sie die E-Mail und alle Anh=C3=A4nge.  Vielen Dank.

This e-mail is confidential.  If you are not the right addressee please do =
not
forward it, please inform the sender, and please erase this e-mail including
any attachments.  Thanks.




Message sent:


Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable
MIME-Version: 1.0
X-Mailer: MIME-tools 5.505 (Entity 5.505)
Content-Type: text/plain; charset=utf-8
X-Loop: help-debbugs@HIDDEN
From: help-debbugs@HIDDEN (GNU bug Tracking System)
To: Philipp Stephani <p.stephani2@HIDDEN>
Subject: bug#23486: Acknowledgement (25.0.93; Modules: features missing
 from make_function)
Message-ID: <handler.23486.B.146281189924474.ack <at> debbugs.gnu.org>
References: <wvr4a8jzchll.fsf@HIDDEN>
X-Gnu-PR-Message: ack 23486
X-Gnu-PR-Package: emacs
Reply-To: 23486 <at> debbugs.gnu.org
Date: Mon, 09 May 2016 16:39:02 +0000

Thank you for filing a new bug report with debbugs.gnu.org.

This is an automatically generated reply to let you know your message
has been received.

Your message is being forwarded to the package maintainers and other
interested parties for their attention; they will reply in due course.

Your message has been sent to the package maintainer(s):
 bug-gnu-emacs@HIDDEN

If you wish to submit further information on this problem, please
send it to 23486 <at> debbugs.gnu.org.

Please do not send mail to help-debbugs@HIDDEN unless you wish
to report a problem with the Bug-tracking system.

--=20
23486: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D23486
GNU Bug Tracking System
Contact help-debbugs@HIDDEN with problems


Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#23486: 25.0.93; Modules: features missing from make_function
Resent-From: Philipp Stephani <p.stephani2@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 11 Sep 2016 14:15:02 +0000
Resent-Message-ID: <handler.23486.B23486.147360324229964 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 23486
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: 23486 <at> debbugs.gnu.org
Received: via spool by 23486-submit <at> debbugs.gnu.org id=B23486.147360324229964
          (code B ref 23486); Sun, 11 Sep 2016 14:15:02 +0000
Received: (at 23486) by debbugs.gnu.org; 11 Sep 2016 14:14:02 +0000
Received: from localhost ([127.0.0.1]:56535 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bj5WE-0007nA-8a
	for submit <at> debbugs.gnu.org; Sun, 11 Sep 2016 10:14:02 -0400
Received: from mail-wm0-f41.google.com ([74.125.82.41]:35671)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <p.stephani2@HIDDEN>) id 1bj5WC-0007mg-G9
 for 23486 <at> debbugs.gnu.org; Sun, 11 Sep 2016 10:14:01 -0400
Received: by mail-wm0-f41.google.com with SMTP id a6so17043916wmc.0
 for <23486 <at> debbugs.gnu.org>; Sun, 11 Sep 2016 07:14:00 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to;
 bh=XhdXcJo9J9Q/V/+FIxoN9pp9V7JbdY9GrX61kvTTVG8=;
 b=vB/IYVcwbaF3y6TpkfhAdjeh83KS6cSmsxGHrU6zHjHJyLJCKtdcig6N6+6sX8+1Rh
 yLXN+XD9MPV5hDh5bGW5QX2tw/zBcFX5bIdRY4DO0rjJzjXjjuoHWLdeKsyPaVaUlE4i
 jHSNrE6LpQXyP4lG60eP8YqAobko0ECqbwDfQwZ/fybdAP8gpLxhRL3kLr8om/dgRl8A
 6ZJ73L30gYU3BJuY+qJwdYwCQ4LD89ojOXRY1cJlt4YMgqnA20+DJaZu5mY4EJTp8MDU
 HIayxbapYZaboMf10IzQgU6VgtdiGJXw0iOYBNrx+fDy3AKHmWIin+ZMskW6bcfoOrPZ
 M/Lg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to;
 bh=XhdXcJo9J9Q/V/+FIxoN9pp9V7JbdY9GrX61kvTTVG8=;
 b=HcXickfnO1ahZvzZkVBN3UxNo7Knrv2e7+YIXbiURelrNivhv06YZy39A/HYjN1Q9m
 26lt4lBSqBvTzdQASIWS1OxWPn7i6INVImtOkBwsyeqpzgMW5Inq6AdTGRNuKYzgb76B
 Hcq+viSXB37XPZKVR7OlZAb3CWz+Un3CsURgDj2tSAVdT2t/GuJJOs7QQo3N05g+Gdt4
 Q3OoGYzLxXJh4V50g4xrYBzmMEfnHWhy7LXliFuy1NtJu/pvcVD0vt4xA2zY0hLsqr15
 J0I6dihl+Gq7pG61Ve4j38XN1EU1jgfmDfjuN5bi/+SFpGIc7Z3YdpKCkArEjrZR52FH
 Jinw==
X-Gm-Message-State: AE9vXwPppgqrHrGhwkX0nPzjAHI3CEWax4p5QdT1HJYNkeobtsOyf+DceEJBFC6VWiTCjRFjjDMyzMP6j2hLCw==
X-Received: by 10.28.74.217 with SMTP id n86mr7063663wmi.84.1473603234457;
 Sun, 11 Sep 2016 07:13:54 -0700 (PDT)
MIME-Version: 1.0
References: <wvr4a8jzchll.fsf@HIDDEN>
In-Reply-To: <wvr4a8jzchll.fsf@HIDDEN>
From: Philipp Stephani <p.stephani2@HIDDEN>
Date: Sun, 11 Sep 2016 14:13:43 +0000
Message-ID: <CAArVCkTyZmJS9haHMoz3xZMH7zqQpqZB4YF8pQv4OS4NPFLpCw@HIDDEN>
Content-Type: multipart/mixed; boundary=001a114e2e3a548999053c3bfde5
X-Spam-Score: -0.5 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

--001a114e2e3a548999053c3bfde5
Content-Type: multipart/alternative; boundary=001a114e2e3a548995053c3bfde3

--001a114e2e3a548995053c3bfde3
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

Philipp Stephani <p.stephani2@HIDDEN> schrieb am Mo., 9. Mai 2016 um
18:39 Uhr:

>
> emacs_env::make_function lacks the following features supported by
> `defun':
>
> 1. Functions with both optional and rest arguments.
> 2. Specification of parameter names.
> 3. Integration with `help-function-arglist'.
> 4. Specification of interactive forms.
> 5. Specification of declare forms.
> 6. Docstrings containing null or non-Unicode characters.
>
> (6) is probably rather unimportant.  (5) is probably not implementable
> (would require wrapping `defun', not `lambda').  (1)=E2=80=93(4) are more=
 severe
> and quite limit the usefulness of make_function right now; for a
> truly generic `defun'-like construct one currently has to eval a `defun'
> form wrapping another function.
>
> To solve (1)=E2=80=93(3), I'd propose replacing the "arity" arguments wit=
h a
> true arglist specification.  This could either be at the C level, e.g.
>
>     ptrdiff_t num_mandatory_args, char** mandatory_arg_names,
>     ptrdiff_t num_optional_args, char** optional_arg_names,
>     char* rest_arg_name
>
> or by requiring to pass a Lisp argument list.
>

I've attached a patch for fixing (1)-(4) and (6).

--001a114e2e3a548995053c3bfde3
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><br><br><div class=3D"gmail_quote"><div dir=3D"ltr">Philip=
p Stephani &lt;<a href=3D"mailto:p.stephani2@HIDDEN">p.stephani2@HIDDEN=
om</a>&gt; schrieb am Mo., 9. Mai 2016 um 18:39=C2=A0Uhr:<br></div><blockqu=
ote class=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1px #ccc s=
olid;padding-left:1ex"><br class=3D"gmail_msg">
emacs_env::make_function lacks the following features supported by<br class=
=3D"gmail_msg">
`defun&#39;:<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
1. Functions with both optional and rest arguments.<br class=3D"gmail_msg">
2. Specification of parameter names.<br class=3D"gmail_msg">
3. Integration with `help-function-arglist&#39;.<br class=3D"gmail_msg">
4. Specification of interactive forms.<br class=3D"gmail_msg">
5. Specification of declare forms.<br class=3D"gmail_msg">
6. Docstrings containing null or non-Unicode characters.<br class=3D"gmail_=
msg">
<br class=3D"gmail_msg">
(6) is probably rather unimportant.=C2=A0 (5) is probably not implementable=
<br class=3D"gmail_msg">
(would require wrapping `defun&#39;, not `lambda&#39;).=C2=A0 (1)=E2=80=93(=
4) are more severe<br class=3D"gmail_msg">
and quite limit the usefulness of make_function right now; for a<br class=
=3D"gmail_msg">
truly generic `defun&#39;-like construct one currently has to eval a `defun=
&#39;<br class=3D"gmail_msg">
form wrapping another function.<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
To solve (1)=E2=80=93(3), I&#39;d propose replacing the &quot;arity&quot; a=
rguments with a<br class=3D"gmail_msg">
true arglist specification.=C2=A0 This could either be at the C level, e.g.=
<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
=C2=A0 =C2=A0 ptrdiff_t num_mandatory_args, char** mandatory_arg_names,<br =
class=3D"gmail_msg">
=C2=A0 =C2=A0 ptrdiff_t num_optional_args, char** optional_arg_names,<br cl=
ass=3D"gmail_msg">
=C2=A0 =C2=A0 char* rest_arg_name<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
or by requiring to pass a Lisp argument list.<br class=3D"gmail_msg">
</blockquote><div><br></div><div>I&#39;ve attached a patch for fixing (1)-(=
4) and (6).=C2=A0</div></div></div>

--001a114e2e3a548995053c3bfde3--

--001a114e2e3a548999053c3bfde5
Content-Type: application/octet-stream; 
	name="0001-Introduce-new-module-function-make_function_ext.patch"
Content-Disposition: attachment; 
	filename="0001-Introduce-new-module-function-make_function_ext.patch"
Content-Transfer-Encoding: base64
Content-ID: <1571998aa6f687a050a1>
X-Attachment-Id: 1571998aa6f687a050a1
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--001a114e2e3a548999053c3bfde5--




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#23486: 25.0.93; Modules: features missing from make_function
Resent-From: npostavs@HIDDEN
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 11 Sep 2016 14:58:01 +0000
Resent-Message-ID: <handler.23486.B23486.14736058261330 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 23486
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Philipp Stephani <p.stephani2@HIDDEN>
Cc: 23486 <at> debbugs.gnu.org
Received: via spool by 23486-submit <at> debbugs.gnu.org id=B23486.14736058261330
          (code B ref 23486); Sun, 11 Sep 2016 14:58:01 +0000
Received: (at 23486) by debbugs.gnu.org; 11 Sep 2016 14:57:06 +0000
Received: from localhost ([127.0.0.1]:56542 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bj6Bt-0000LO-QS
	for submit <at> debbugs.gnu.org; Sun, 11 Sep 2016 10:57:05 -0400
Received: from mail-oi0-f45.google.com ([209.85.218.45]:33725)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <npostavs@HIDDEN>) id 1bj6Br-0000Ku-LR
 for 23486 <at> debbugs.gnu.org; Sun, 11 Sep 2016 10:57:03 -0400
Received: by mail-oi0-f45.google.com with SMTP id y2so255348431oie.0
 for <23486 <at> debbugs.gnu.org>; Sun, 11 Sep 2016 07:57:03 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=sender:from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version:content-transfer-encoding;
 bh=0bagMmrFtiOodiNkdyutbbcFDK7/4fNBIQ3Tq4W4zSE=;
 b=E8fOo/+vDX0k4Pp/k8RUrlkpxvjf6aDkehmS2x2O3WdZBzM7GWqZIGkivAS4xXj5oa
 G1xBf/CZMvSml1UhhnLkFfKyOl3Ig9JtC6Wy6gS1AOYJ1LD4+YHeDe8WEnZhm/t4H2d5
 f1gr5NcyOwRqlqCrqopVYb+pM8VfI+iVWxZx87oG2wAKX6AQ5YpgV6b7jumxVLMRFz3P
 5Wn6NnhqqDXSTZ3E1gOJ/t1qfjOzGrH4/U+1vk6mzCrSZCndM7EkHPb0yfhuhmDLA+Zv
 vVBYZE0oMAI4ZZGInwhoXZqz+xBSnFh6PQ1YgfHNtAWJpEAcbTfAfDXRi1cWapbYcXLS
 TYjA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20130820;
 h=x-gm-message-state:sender:from:to:cc:subject:references:date
 :in-reply-to:message-id:user-agent:mime-version
 :content-transfer-encoding;
 bh=0bagMmrFtiOodiNkdyutbbcFDK7/4fNBIQ3Tq4W4zSE=;
 b=Rrxv642hQmhpZkHcFayDDSQDBJDT5u3FmTjCwH0czh1DoWX0DsXuZM83xCPBeGNr0Y
 IYRd06/y34c8Vn88GuUiwu8gvTIi9dvIaBTBNh0OWDsr5SqJ+IO3Hkzz2idI7BVWlyZp
 H4jxMIy8/79esJbZkhSpmqWYy+rfOehf+92G2MpNyc7BC1LGqep94osWTz329hwIl4FE
 W9TTw7kOaTqaj5t6Z72edd8sNEmNnpEJuEgHu909PunFAOiNUr2sHWRqK/3pzVGJOS6y
 2ODKvN0Jkt8GSWN+VDVzlLNnUCRagCxF4MV8u7WsjGxeajbiy62Qik+2as913rDldFvF
 KSZg==
X-Gm-Message-State: AE9vXwOu8CS9L+UDX+vj85QjxkTeoXkkc7qpWkpfuyPT8oh7VoGpKWNSAfBj/Bj8AqgDKA==
X-Received: by 10.202.92.197 with SMTP id q188mr18968399oib.79.1473605817937; 
 Sun, 11 Sep 2016 07:56:57 -0700 (PDT)
Received: from zony ([45.2.7.130])
 by smtp.googlemail.com with ESMTPSA id w71sm7545282ith.2.2016.09.11.07.56.57
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sun, 11 Sep 2016 07:56:57 -0700 (PDT)
From: npostavs@HIDDEN
References: <wvr4a8jzchll.fsf@HIDDEN>
Date: Sun, 11 Sep 2016 10:57:18 -0400
In-Reply-To: <wvr4a8jzchll.fsf@HIDDEN> (Philipp Stephani's
 message of "Mon, 09 May 2016 18:37:58 +0200")
Message-ID: <87inu21o35.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.7 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Philipp Stephani <p.stephani2@HIDDEN> writes:

> emacs_env::make_function lacks the following features supported by
> `defun':
>
> 1. Functions with both optional and rest arguments.
> 2. Specification of parameter names.
> 3. Integration with `help-function-arglist'.
> 4. Specification of interactive forms.
> 5. Specification of declare forms.
> 6. Docstrings containing null or non-Unicode characters.
>
> (6) is probably rather unimportant.  (5) is probably not implementable
> (would require wrapping `defun', not `lambda').  (1)=E2=80=93(4) are more=
 severe
> and quite limit the usefulness of make_function right now; for a
> truly generic `defun'-like construct one currently has to eval a `defun'
> form wrapping another function.

Shouldn't modules be providing a DEFUN-like construct instead?  That is,
I thought the idea of modules was to enable writing primitive
subroutines.

>
> To solve (1)=E2=80=93(3), I'd propose replacing the "arity" arguments wit=
h a
> true arglist specification.  This could either be at the C level, e.g.
>
>     ptrdiff_t num_mandatory_args, char** mandatory_arg_names,
>     ptrdiff_t num_optional_args, char** optional_arg_names,
>     char* rest_arg_name
>
> or by requiring to pass a Lisp argument list.
>
> To solve (4) I'd propose to pass another value for the interactive form,
> probably as emacs_value* (to support non-interactive functions).
>
> As an alternative, if people feel this would require too many
> parameters, I'd propose reverting the change that adds the documentation
> string.  A docstring without arglist is not very useful.  We could also
> remove the arity parameters and have the C function check the arity
> itself.

I think adding "(fn ARG1 ARG2...)" to the docstring would solve (1)-(3).
What's lacking is a way to add this automagically like DEFUN does.  And
getting the parameters in C variables like DEFUN would also be nice.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#23486: 25.0.93; Modules: features missing from make_function
Resent-From: Philipp Stephani <p.stephani2@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 26 Mar 2017 20:03:02 +0000
Resent-Message-ID: <handler.23486.B23486.149055854726541 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 23486
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: npostavs@HIDDEN
Cc: 23486 <at> debbugs.gnu.org
Received: via spool by 23486-submit <at> debbugs.gnu.org id=B23486.149055854726541
          (code B ref 23486); Sun, 26 Mar 2017 20:03:02 +0000
Received: (at 23486) by debbugs.gnu.org; 26 Mar 2017 20:02:27 +0000
Received: from localhost ([127.0.0.1]:46215 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1csEMt-0006u1-06
	for submit <at> debbugs.gnu.org; Sun, 26 Mar 2017 16:02:27 -0400
Received: from mail-wr0-f173.google.com ([209.85.128.173]:35316)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <p.stephani2@HIDDEN>) id 1csEMr-0006to-7t
 for 23486 <at> debbugs.gnu.org; Sun, 26 Mar 2017 16:02:25 -0400
Received: by mail-wr0-f173.google.com with SMTP id u1so28680560wra.2
 for <23486 <at> debbugs.gnu.org>; Sun, 26 Mar 2017 13:02:25 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=n/wtF8ohszLLrKctCL4Imp0wfQBt81XdIGdc3y+W0ok=;
 b=BH0fzP59BzU13Z+c6VfFVSWTi4809RtLemHsibj8c5sSJTphq2yXBy0QKPA0w+okTn
 SVIL541V1M52jC9S/t0F2R4xhIXhrUXMctqzDbN5G9DWGJllMy8NvToTC+8D7GerzV/a
 EJPBI3/0NJgCvnA906rCVoiB95T47YkZgae2uzPPwxCZqWaVqUi6ZToggIxuinLN2kJS
 fn8xlHpvi64doFVYtiqlX2JxtTzaXJhX0RfABiryvXfLyd7ECHA5q3pZzF9LGs8T1xIJ
 sbCAlklpNY7nInvsHE6BhN0b3tuErioLUkBAyGsyu8cDqR8yETb54VO+sdOR2HKxP7ke
 JLkQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=n/wtF8ohszLLrKctCL4Imp0wfQBt81XdIGdc3y+W0ok=;
 b=TW8mbD0rb0iDyfuyYV9vbdDi/LAFgZli+4x889Ry5O1CT4IeyTT/+PzjWzj70OCLCM
 /t5Q/v3I+dP+VGhgD5kLvlkf5jfSP4yzmMq6oP+MFqyOB62G0UTXiqcKWgxYFcg0aBBT
 W1nB6iKGGD1woPIZAyyjgsm2X1fVYu1FDBW4ORU79FHF8cF2rbrbO0fP8lgsUzWOTU1i
 sZLgr4em4UMw8y9RRoWnl9A6VkrHBfOOwwtj3BK9E9M2q2lLNHJ7a6IvIP6sdSBPjMpE
 /tXwLqJpeODMe3C3+m3+XgwG9+i5kXUNgblMFOTaAnggObIijTX74de3EnEVjewO3SKd
 5seA==
X-Gm-Message-State: AFeK/H1Cm+SdeKleHDZFBqt2oQgHiD6pJkj84RUe4+qDekwyi2cujdyus7S9x63EfAcgH0cI6iOd3e3r6cOTWw==
X-Received: by 10.28.220.139 with SMTP id t133mr1344220wmg.95.1490558539448;
 Sun, 26 Mar 2017 13:02:19 -0700 (PDT)
MIME-Version: 1.0
References: <wvr4a8jzchll.fsf@HIDDEN>
 <87inu21o35.fsf@HIDDEN>
In-Reply-To: <87inu21o35.fsf@HIDDEN>
From: Philipp Stephani <p.stephani2@HIDDEN>
Date: Sun, 26 Mar 2017 20:02:08 +0000
Message-ID: <CAArVCkQBmtpRfp7RfY-rXPUqjMfwhXL2GeYHeJyps9Oyeb51fA@HIDDEN>
Content-Type: multipart/alternative; boundary=001a114b311442ca7c054ba7b4c8
X-Spam-Score: -2.5 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.5 (--)

--001a114b311442ca7c054ba7b4c8
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<npostavs@HIDDEN> schrieb am So., 11. Sep. 2016 um 16:56 Uhr=
:

> Philipp Stephani <p.stephani2@HIDDEN> writes:
>
> > emacs_env::make_function lacks the following features supported by
> > `defun':
> >
> > 1. Functions with both optional and rest arguments.
> > 2. Specification of parameter names.
> > 3. Integration with `help-function-arglist'.
> > 4. Specification of interactive forms.
> > 5. Specification of declare forms.
> > 6. Docstrings containing null or non-Unicode characters.
> >
> > (6) is probably rather unimportant.  (5) is probably not implementable
> > (would require wrapping `defun', not `lambda').  (1)=E2=80=93(4) are mo=
re severe
> > and quite limit the usefulness of make_function right now; for a
> > truly generic `defun'-like construct one currently has to eval a `defun=
'
> > form wrapping another function.
>
> Shouldn't modules be providing a DEFUN-like construct instead?  That is,
> I thought the idea of modules was to enable writing primitive
> subroutines.
>

I don't know what the idea of modules originally was. However, defun and
DEFUN are composite operations: They create a function object (lambda) and
provide an alias for it. Therefore they can't replace the more primitive
operations. The current module interface design chooses to provide the
primitive operation to make a function object and have the caller call
defalias. That's a reasonable choice.


>
> >
> > To solve (1)=E2=80=93(3), I'd propose replacing the "arity" arguments w=
ith a
> > true arglist specification.  This could either be at the C level, e.g.
> >
> >     ptrdiff_t num_mandatory_args, char** mandatory_arg_names,
> >     ptrdiff_t num_optional_args, char** optional_arg_names,
> >     char* rest_arg_name
> >
> > or by requiring to pass a Lisp argument list.
> >
> > To solve (4) I'd propose to pass another value for the interactive form=
,
> > probably as emacs_value* (to support non-interactive functions).
> >
> > As an alternative, if people feel this would require too many
> > parameters, I'd propose reverting the change that adds the documentatio=
n
> > string.  A docstring without arglist is not very useful.  We could also
> > remove the arity parameters and have the C function check the arity
> > itself.
>
> I think adding "(fn ARG1 ARG2...)" to the docstring would solve (1)-(3).
>

That doesn't work, because Emacs ignores this syntax when the arguments are
provided explicitly, and since a module function is just a (lambda (&rest
args) ...) under the hood, the arglist is always just (&rest args).


> What's lacking is a way to add this automagically like DEFUN does.  And
> getting the parameters in C variables like DEFUN would also be nice.
>

Maybe, but not for the module interface. The module interface explicitly
only provides basic primitives, without macro magic or high-level
functions. High-level functionality built on top of the primitives is out
of scope.

--001a114b311442ca7c054ba7b4c8
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><br><br><div class=3D"gmail_quote"><div dir=3D"ltr">&lt;<a=
 href=3D"mailto:npostavs@HIDDEN">npostavs@HIDDEN=
net</a>&gt; schrieb am So., 11. Sep. 2016 um 16:56=C2=A0Uhr:<br></div><bloc=
kquote class=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1px #cc=
c solid;padding-left:1ex">Philipp Stephani &lt;<a href=3D"mailto:p.stephani=
2@HIDDEN" class=3D"gmail_msg" target=3D"_blank">p.stephani2@HIDDEN</a=
>&gt; writes:<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
&gt; emacs_env::make_function lacks the following features supported by<br =
class=3D"gmail_msg">
&gt; `defun&#39;:<br class=3D"gmail_msg">
&gt;<br class=3D"gmail_msg">
&gt; 1. Functions with both optional and rest arguments.<br class=3D"gmail_=
msg">
&gt; 2. Specification of parameter names.<br class=3D"gmail_msg">
&gt; 3. Integration with `help-function-arglist&#39;.<br class=3D"gmail_msg=
">
&gt; 4. Specification of interactive forms.<br class=3D"gmail_msg">
&gt; 5. Specification of declare forms.<br class=3D"gmail_msg">
&gt; 6. Docstrings containing null or non-Unicode characters.<br class=3D"g=
mail_msg">
&gt;<br class=3D"gmail_msg">
&gt; (6) is probably rather unimportant.=C2=A0 (5) is probably not implemen=
table<br class=3D"gmail_msg">
&gt; (would require wrapping `defun&#39;, not `lambda&#39;).=C2=A0 (1)=E2=
=80=93(4) are more severe<br class=3D"gmail_msg">
&gt; and quite limit the usefulness of make_function right now; for a<br cl=
ass=3D"gmail_msg">
&gt; truly generic `defun&#39;-like construct one currently has to eval a `=
defun&#39;<br class=3D"gmail_msg">
&gt; form wrapping another function.<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
Shouldn&#39;t modules be providing a DEFUN-like construct instead?=C2=A0 Th=
at is,<br class=3D"gmail_msg">
I thought the idea of modules was to enable writing primitive<br class=3D"g=
mail_msg">
subroutines.<br class=3D"gmail_msg"></blockquote><div><br></div><div>I don&=
#39;t know what the idea of modules originally was. However, defun and DEFU=
N are composite operations: They create a function object (lambda) and prov=
ide an alias for it. Therefore they can&#39;t replace the more primitive op=
erations. The current module interface design chooses to provide the primit=
ive operation to make a function object and have the caller call defalias. =
That&#39;s a reasonable choice.</div><div>=C2=A0</div><blockquote class=3D"=
gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1px #ccc solid;padding-=
left:1ex">
<br class=3D"gmail_msg">
&gt;<br class=3D"gmail_msg">
&gt; To solve (1)=E2=80=93(3), I&#39;d propose replacing the &quot;arity&qu=
ot; arguments with a<br class=3D"gmail_msg">
&gt; true arglist specification.=C2=A0 This could either be at the C level,=
 e.g.<br class=3D"gmail_msg">
&gt;<br class=3D"gmail_msg">
&gt;=C2=A0 =C2=A0 =C2=A0ptrdiff_t num_mandatory_args, char** mandatory_arg_=
names,<br class=3D"gmail_msg">
&gt;=C2=A0 =C2=A0 =C2=A0ptrdiff_t num_optional_args, char** optional_arg_na=
mes,<br class=3D"gmail_msg">
&gt;=C2=A0 =C2=A0 =C2=A0char* rest_arg_name<br class=3D"gmail_msg">
&gt;<br class=3D"gmail_msg">
&gt; or by requiring to pass a Lisp argument list.<br class=3D"gmail_msg">
&gt;<br class=3D"gmail_msg">
&gt; To solve (4) I&#39;d propose to pass another value for the interactive=
 form,<br class=3D"gmail_msg">
&gt; probably as emacs_value* (to support non-interactive functions).<br cl=
ass=3D"gmail_msg">
&gt;<br class=3D"gmail_msg">
&gt; As an alternative, if people feel this would require too many<br class=
=3D"gmail_msg">
&gt; parameters, I&#39;d propose reverting the change that adds the documen=
tation<br class=3D"gmail_msg">
&gt; string.=C2=A0 A docstring without arglist is not very useful.=C2=A0 We=
 could also<br class=3D"gmail_msg">
&gt; remove the arity parameters and have the C function check the arity<br=
 class=3D"gmail_msg">
&gt; itself.<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
I think adding &quot;(fn ARG1 ARG2...)&quot; to the docstring would solve (=
1)-(3).<br class=3D"gmail_msg"></blockquote><div><br></div><div>That doesn&=
#39;t work, because Emacs ignores this syntax when the arguments are provid=
ed explicitly, and since a module function is just a (lambda (&amp;rest arg=
s) ...) under the hood, the arglist is always just (&amp;rest args).</div><=
div>=C2=A0</div><blockquote class=3D"gmail_quote" style=3D"margin:0 0 0 .8e=
x;border-left:1px #ccc solid;padding-left:1ex">
What&#39;s lacking is a way to add this automagically like DEFUN does.=C2=
=A0 And<br class=3D"gmail_msg">
getting the parameters in C variables like DEFUN would also be nice.<br cla=
ss=3D"gmail_msg"></blockquote><div><br></div><div>Maybe, but not for the mo=
dule interface. The module interface explicitly only provides basic primiti=
ves, without macro magic or high-level functions. High-level functionality =
built on top of the primitives is out of scope.=C2=A0</div></div></div>

--001a114b311442ca7c054ba7b4c8--




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#23486: 25.0.93; Modules: features missing from make_function
Resent-From: npostavs@HIDDEN
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 26 Mar 2017 20:22:01 +0000
Resent-Message-ID: <handler.23486.B23486.149055968028191 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 23486
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Philipp Stephani <p.stephani2@HIDDEN>
Cc: 23486 <at> debbugs.gnu.org
Received: via spool by 23486-submit <at> debbugs.gnu.org id=B23486.149055968028191
          (code B ref 23486); Sun, 26 Mar 2017 20:22:01 +0000
Received: (at 23486) by debbugs.gnu.org; 26 Mar 2017 20:21:20 +0000
Received: from localhost ([127.0.0.1]:46231 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1csEfA-0007Kd-C9
	for submit <at> debbugs.gnu.org; Sun, 26 Mar 2017 16:21:20 -0400
Received: from mail-it0-f41.google.com ([209.85.214.41]:37918)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <npostavs@HIDDEN>) id 1csEf8-0007KQ-6n
 for 23486 <at> debbugs.gnu.org; Sun, 26 Mar 2017 16:21:19 -0400
Received: by mail-it0-f41.google.com with SMTP id y18so33654066itc.1
 for <23486 <at> debbugs.gnu.org>; Sun, 26 Mar 2017 13:21:18 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=Z6VX5Y0oaULxrKQEhyXGI3+VWyaywnsaJDeOepe3fRA=;
 b=q6gVmLjaZUAFN09wBl21HkUredqcJjFYFr+586VHwAuTRmj0HTCKQa0S6Of1ZrobAz
 nnWqjaMrvcrKwxgPpKPLWWAmNjMYaKjV0XDxq/2d+aYKaY5lQ13hRvCh/Ojn3G3NSQsS
 qMAJ/U9RIwVBeIJFAl2nQsOpIUWs2jdYYAlVw+0mhkBGyxXe6ZKwacta/xOkbneMiKHe
 fLpp4XitGfSHwNdvWQreXYu4nOmGgASfXSb+jDmtMsSXscSfJ0vdtMxQPVwFL0WtYggu
 5LcSnu84GSoZk99S8esSSybC06zcqhndSAAnzUdVTXfYyZc5NShi9+0dW5Hlkhl3WGQC
 Q0kg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:from:to:cc:subject:references:date
 :in-reply-to:message-id:user-agent:mime-version;
 bh=Z6VX5Y0oaULxrKQEhyXGI3+VWyaywnsaJDeOepe3fRA=;
 b=J/icYakzeN7PorzMw+xYJjwvlRpMmXmbzHxLryO1NRnD7sAAaNk+yqfQG4nFff3CtI
 BQeSFKnBrCqJQU9VVS4Jod34NyBCl8mFf8jkDpZhHjXPa/+eqmsIBD3z3ows4kbcOe/R
 evHnb4Morvd+G9+k1kt+ZgBfTr3wKBtWk8Nl4lufbrHpSxsMHfaZBDBfDQRyZoKxx9RZ
 pSucFwlTJUcssqLrp0MkQ8yBoEs2JP30eRRlarvrqs4xkGBSIB2+YjPGo8/eDWHqQvxl
 AUcrDKVF3zzQxApw0n/tl4C3YsKvWMk8iEsT7msqUS52nM0TKCn8xM5rXnVJ53pTX5Oq
 OXCw==
X-Gm-Message-State: AFeK/H2yekvLp9CR8w/sYKR5VnagPQQ5WYv5LGWnL2YCMS5a+eOuosilsFFk0xjVgl4zgQ==
X-Received: by 10.107.130.210 with SMTP id m79mr17453888ioi.38.1490559672494; 
 Sun, 26 Mar 2017 13:21:12 -0700 (PDT)
Received: from zony ([45.2.7.65])
 by smtp.googlemail.com with ESMTPSA id 78sm4377622ity.7.2017.03.26.13.21.11
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sun, 26 Mar 2017 13:21:11 -0700 (PDT)
From: npostavs@HIDDEN
References: <wvr4a8jzchll.fsf@HIDDEN>
 <87inu21o35.fsf@HIDDEN>
 <CAArVCkQBmtpRfp7RfY-rXPUqjMfwhXL2GeYHeJyps9Oyeb51fA@HIDDEN>
Date: Sun, 26 Mar 2017 16:22:32 -0400
In-Reply-To: <CAArVCkQBmtpRfp7RfY-rXPUqjMfwhXL2GeYHeJyps9Oyeb51fA@HIDDEN>
 (Philipp Stephani's message of "Sun, 26 Mar 2017 20:02:08 +0000")
Message-ID: <877f3b4wl3.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.7 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.7 (/)

Philipp Stephani <p.stephani2@HIDDEN> writes:

>
>>  I think adding "(fn ARG1 ARG2...)" to the docstring would solve (1)-(3).
>
> That doesn't work, because Emacs ignores this syntax when the
> arguments are provided explicitly, and since a module function is just
> a (lambda (&rest args) ...) under the hood, the arglist is always just
> (&rest args).

I don't know what you mean here.

    (defun foo (&rest args)
      "Do foo.

    \(fn ARG1 ARG2)")

<f1> f foo RET gives

    foo is a Lisp function.

    (foo ARG1 ARG2)

    Do foo.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#23486: 25.0.93; Modules: features missing from make_function
Resent-From: Philipp Stephani <p.stephani2@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 26 Mar 2017 20:41:01 +0000
Resent-Message-ID: <handler.23486.B23486.149056081830085 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 23486
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: npostavs@HIDDEN
Cc: 23486 <at> debbugs.gnu.org
Received: via spool by 23486-submit <at> debbugs.gnu.org id=B23486.149056081830085
          (code B ref 23486); Sun, 26 Mar 2017 20:41:01 +0000
Received: (at 23486) by debbugs.gnu.org; 26 Mar 2017 20:40:18 +0000
Received: from localhost ([127.0.0.1]:46242 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1csExW-0007pB-8C
	for submit <at> debbugs.gnu.org; Sun, 26 Mar 2017 16:40:18 -0400
Received: from mail-wr0-f180.google.com ([209.85.128.180]:33820)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <p.stephani2@HIDDEN>) id 1csExU-0007ox-6i
 for 23486 <at> debbugs.gnu.org; Sun, 26 Mar 2017 16:40:16 -0400
Received: by mail-wr0-f180.google.com with SMTP id l43so29352486wre.1
 for <23486 <at> debbugs.gnu.org>; Sun, 26 Mar 2017 13:40:16 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=+Tw+uMOIB6vYuETagIsl3upPKfhvGoEJycycYcqxLk0=;
 b=kth4vdw05r03wLWM6OlJQkE/GtjpZ6+H8SjTXQJbKBLJjpAX3py0CjB4Qu3em7EhZK
 EkQANqyArlk/Lpef0VQN86LojTrqgvmbXILyKfCHlUVVIzf03IpBOcJkgznJujjzLK+p
 XUJtv2piWwXHj4D9rNO98Vd4LEcaMXlvfOaqxGCDJu/hrRp0pWkvc4+EurI56lGk0Acf
 ewzUpSqdyhHMyberuGJQhFlGWahbrhh0w3fhsDlREXE7ZN8dcBb5BeK57kf5y5j+npuK
 HwI8q65Pr/GeK9IOq67Rn4HRtrSPJnnSXjHHZvC4fvq/tW4Qm6tF0+J8SxC/wNOJ3KsJ
 hCNg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=+Tw+uMOIB6vYuETagIsl3upPKfhvGoEJycycYcqxLk0=;
 b=STZ9nQvDvlcjvclooPUMNrVj+uXnejx7zy+R9svfDbCI/abc4VTaBfgVGUbESMiTGv
 VgzFy1gOR/b3lpoWQjAPIUCq40Phg12aD0V4EJA8LqXzJm/TN/kUMao8y6CDBAPNUXI6
 rCd9wC0lasK/8yUJaRZiaA04y7qI8kLfv+0ytEAgtqF8gqp/8ccIZHJpHUGcmpNoB5ds
 MoayyQZoDxC1Bu/qBDYspABScBwedHPRuQKXRBlhwGvJ2XD0nItN5+70k+SxXNdSpAZH
 RpmSa0T0m6q/qYS5785Fb20Ny5prAAU1lJ+joYEeRwWfodZzQTv/1OJeN2LzmqPFBN0q
 o4Bg==
X-Gm-Message-State: AFeK/H3y7rDmZzy48URnN+St13JamBGJlqy/gFeBgzM47QX5CLO6C2T3IFJC/rPPsDjTeSoPNi0wEtonPceCTw==
X-Received: by 10.28.216.208 with SMTP id p199mr6618951wmg.44.1490560810545;
 Sun, 26 Mar 2017 13:40:10 -0700 (PDT)
MIME-Version: 1.0
References: <wvr4a8jzchll.fsf@HIDDEN>
 <87inu21o35.fsf@HIDDEN>
 <CAArVCkQBmtpRfp7RfY-rXPUqjMfwhXL2GeYHeJyps9Oyeb51fA@HIDDEN>
 <877f3b4wl3.fsf@HIDDEN>
In-Reply-To: <877f3b4wl3.fsf@HIDDEN>
From: Philipp Stephani <p.stephani2@HIDDEN>
Date: Sun, 26 Mar 2017 20:40:00 +0000
Message-ID: <CAArVCkRqv9oN__MadfpbWg-PDt5DbhBG7R48ZhnTLH7Eq_Mmkw@HIDDEN>
Content-Type: multipart/alternative; boundary=001a114733c0a0f960054ba83b2a
X-Spam-Score: -2.5 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.5 (--)

--001a114733c0a0f960054ba83b2a
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<npostavs@HIDDEN> schrieb am So., 26. M=C3=A4rz 2017 um 22:2=
1 Uhr:

> Philipp Stephani <p.stephani2@HIDDEN> writes:
>
> >
> >>  I think adding "(fn ARG1 ARG2...)" to the docstring would solve
> (1)-(3).
> >
> > That doesn't work, because Emacs ignores this syntax when the
> > arguments are provided explicitly, and since a module function is just
> > a (lambda (&rest args) ...) under the hood, the arglist is always just
> > (&rest args).
>
> I don't know what you mean here.
>
>     (defun foo (&rest args)
>       "Do foo.
>
>     \(fn ARG1 ARG2)")
>
> <f1> f foo RET gives
>
>     foo is a Lisp function.
>
>     (foo ARG1 ARG2)
>
>     Do foo.
>

OK, that one works, but others don't (e.g. help-function-arglist). The
argument names should be transparent, without having to use such tricks.

--001a114733c0a0f960054ba83b2a
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><br><br><div class=3D"gmail_quote"><div dir=3D"ltr">&lt;<a=
 href=3D"mailto:npostavs@HIDDEN">npostavs@HIDDEN=
net</a>&gt; schrieb am So., 26. M=C3=A4rz 2017 um 22:21=C2=A0Uhr:<br></div>=
<blockquote class=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1p=
x #ccc solid;padding-left:1ex">Philipp Stephani &lt;<a href=3D"mailto:p.ste=
phani2@HIDDEN" class=3D"gmail_msg" target=3D"_blank">p.stephani2@HIDDEN=
om</a>&gt; writes:<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
&gt;<br class=3D"gmail_msg">
&gt;&gt;=C2=A0 I think adding &quot;(fn ARG1 ARG2...)&quot; to the docstrin=
g would solve (1)-(3).<br class=3D"gmail_msg">
&gt;<br class=3D"gmail_msg">
&gt; That doesn&#39;t work, because Emacs ignores this syntax when the<br c=
lass=3D"gmail_msg">
&gt; arguments are provided explicitly, and since a module function is just=
<br class=3D"gmail_msg">
&gt; a (lambda (&amp;rest args) ...) under the hood, the arglist is always =
just<br class=3D"gmail_msg">
&gt; (&amp;rest args).<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
I don&#39;t know what you mean here.<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
=C2=A0 =C2=A0 (defun foo (&amp;rest args)<br class=3D"gmail_msg">
=C2=A0 =C2=A0 =C2=A0 &quot;Do foo.<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
=C2=A0 =C2=A0 \(fn ARG1 ARG2)&quot;)<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
&lt;f1&gt; f foo RET gives<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
=C2=A0 =C2=A0 foo is a Lisp function.<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
=C2=A0 =C2=A0 (foo ARG1 ARG2)<br class=3D"gmail_msg">
<br class=3D"gmail_msg">
=C2=A0 =C2=A0 Do foo.<br class=3D"gmail_msg"></blockquote><div><br></div><d=
iv>OK, that one works, but others don&#39;t (e.g. help-function-arglist). T=
he argument names should be transparent, without having to use such tricks.=
=C2=A0</div></div></div>

--001a114733c0a0f960054ba83b2a--




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#23486: 25.0.93; Modules: features missing from make_function
Resent-From: npostavs@HIDDEN
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Mon, 27 Mar 2017 03:57:02 +0000
Resent-Message-ID: <handler.23486.B23486.14905869675753 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 23486
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Philipp Stephani <p.stephani2@HIDDEN>
Cc: 23486 <at> debbugs.gnu.org
Received: via spool by 23486-submit <at> debbugs.gnu.org id=B23486.14905869675753
          (code B ref 23486); Mon, 27 Mar 2017 03:57:02 +0000
Received: (at 23486) by debbugs.gnu.org; 27 Mar 2017 03:56:07 +0000
Received: from localhost ([127.0.0.1]:46634 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1csLlH-0001Uj-8N
	for submit <at> debbugs.gnu.org; Sun, 26 Mar 2017 23:56:07 -0400
Received: from mail-it0-f47.google.com ([209.85.214.47]:38799)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <npostavs@HIDDEN>) id 1csLlF-0001UB-DM
 for 23486 <at> debbugs.gnu.org; Sun, 26 Mar 2017 23:56:05 -0400
Received: by mail-it0-f47.google.com with SMTP id y18so39545200itc.1
 for <23486 <at> debbugs.gnu.org>; Sun, 26 Mar 2017 20:56:05 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=9vmj0OGPv/cjeT8LhMEB2Q89usFpDddSkjlHKAAml9Q=;
 b=lLTg/2Ww+A2wr6OhLPYqiOAIz8NxO3oRJNvNH7kPvOPVdPQikvIumxP6wY/4BM6y8A
 0dHPcQ/fcA0tfB0uQNw5NI6CG3peg+wWqpwdklEWj0lR6HM1NRfv4gLsUgHiFIj+JYtt
 DsmEp3ezy1gJ5kWwWUwXmHv9BVgOjDAaRM6U5ogrUlPCHOg5sVUKYSSRH35RTpvCtWIU
 vyIZkDpvPcVi+ccLA9XsdAXMxO1o9w4xvTcvF37PdPurmeUMTbaL7fKcXM9wDs1061DT
 2ZMASh9T7Inb8+s4EUdaxIOZOjMcUr10V8/sxGLVW/WmuOHY03+wLJfwn+MDMxGrvo3n
 IYDg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:from:to:cc:subject:references:date
 :in-reply-to:message-id:user-agent:mime-version;
 bh=9vmj0OGPv/cjeT8LhMEB2Q89usFpDddSkjlHKAAml9Q=;
 b=tyElBvsDtc8DIqOHivx9kSsGpOa0D5N0zYGNaGcMYGRyHgL3LUDhuY+3+hJT5y8E3O
 VylPrZtFYqYYejIzKOYAQDZwv/Fdq3Jh+Kf4PJ7AaDq6KVtHQcMJUFPZ+XdtpSjKgp19
 18qphwHeJHYx7qz3qUecdNboJX1hKNuIVOUnvNHnqLlV2oDnPOB+fOvJcP6zS1DeZdq/
 UVn60cOxserHqBYsqaalY6q9T880LtlI5koIzJGQHm7Bcdxwrx/a75EQ78f5RZ20Xu+L
 sVwlwwNcDjebvVo4KcV5JvToK5NjK0BEgSAiAiuPKJoLrmGFQh+Kl8XdIdG9PDJdKSm2
 8zbA==
X-Gm-Message-State: AFeK/H3elaDSgcecEl2TbUJ/9SKU8ib5aIq+NLwQzdZtpmlqf++x6httYMTX90Toy0rNyQ==
X-Received: by 10.36.89.211 with SMTP id p202mr8493540itb.97.1490586959812;
 Sun, 26 Mar 2017 20:55:59 -0700 (PDT)
Received: from zony ([45.2.7.65])
 by smtp.googlemail.com with ESMTPSA id r197sm4872599itb.15.2017.03.26.20.55.59
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sun, 26 Mar 2017 20:55:59 -0700 (PDT)
From: npostavs@HIDDEN
References: <wvr4a8jzchll.fsf@HIDDEN>
Date: Sun, 26 Mar 2017 23:57:20 -0400
In-Reply-To: <wvr4a8jzchll.fsf@HIDDEN> (Philipp Stephani's
 message of "Mon, 09 May 2016 18:37:58 +0200")
Message-ID: <871stj4bj3.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.7 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.7 (/)

Philipp Stephani <p.stephani2@HIDDEN> writes:

> As an alternative, if people feel this would require too many
> parameters, I'd propose reverting the change that adds the documentation
> string.  A docstring without arglist is not very useful.  We could also
> remove the arity parameters and have the C function check the arity
> itself.

Looking at this a bit closer, I do think this adds too many parameters,
and in particular, requiring to pass in names for positional parameters
just makes no sense.  The names are never used (except for displaying
documentation).

But removing the docstring is not great.  IMO, the right solution here
is to use a subr-like object instead of a lambda, as suggested in a
FIXME in emacs-module.c:

  /* FIXME: Use a bytecompiled object, or even better a subr.  */

Then the arity could be checked with `subr-arity' or similar.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#23486: 25.0.93; Modules: features missing from make_function
Resent-From: Philipp Stephani <p.stephani2@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Tue, 04 Jul 2017 18:21:02 +0000
Resent-Message-ID: <handler.23486.B23486.14991924225200 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 23486
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: npostavs@HIDDEN
Cc: 23486 <at> debbugs.gnu.org
Received: via spool by 23486-submit <at> debbugs.gnu.org id=B23486.14991924225200
          (code B ref 23486); Tue, 04 Jul 2017 18:21:02 +0000
Received: (at 23486) by debbugs.gnu.org; 4 Jul 2017 18:20:22 +0000
Received: from localhost ([127.0.0.1]:52423 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dSSQw-0001Ln-LM
	for submit <at> debbugs.gnu.org; Tue, 04 Jul 2017 14:20:22 -0400
Received: from mail-oi0-f43.google.com ([209.85.218.43]:36164)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <p.stephani2@HIDDEN>) id 1dSSQu-0001LY-JT
 for 23486 <at> debbugs.gnu.org; Tue, 04 Jul 2017 14:20:20 -0400
Received: by mail-oi0-f43.google.com with SMTP id x187so51644817oig.3
 for <23486 <at> debbugs.gnu.org>; Tue, 04 Jul 2017 11:20:20 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=A/fq8OceJLH8phFzbxJifXeC7sud4CAP+JR5aTM7tZI=;
 b=J8HbV4ou4faTlXmH0YHzFQKgG6lTYa16gEuADGBffasH/1tKma7awXExgRdtwcYoTu
 x8QoLZbAtp9boxLeLt97ejAT+a+VYIwt9WJqp5oyd2PFP+DKpuxx9yNKajE1DfOcIpGi
 fSIJ1OrtStGT+jFqkJRmtsYv7C6lsCu5fPcGD9b/GZ30EKekEBxMQp4sA1oTCWtWjJpW
 oYvPw1SIeQ0cVZ370YAP8djAdNxWNFcutdyGdDmAKx2UoOsNKDz8c/jdJv0Sf+nBBxk4
 Ycp8nzNQY1yrMK8ynH45Q51CDSH15OqpqaCLclmwyd5jci7PUgHhfEH2sxNPBS2QyYig
 G6TQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=A/fq8OceJLH8phFzbxJifXeC7sud4CAP+JR5aTM7tZI=;
 b=oYJswmbE6PIb3b7LmGnTPlSG57pVCzm/RN9CFkiggRWMcZrl8dAlctJ+LTmNQ/JhxZ
 jSYHNbntOy2uoGFfLQEg7jBtgpaZ59sykUJaUlsTipu1DvQ76ZOaXf1KOSInKoiPVrVR
 iwEFi8jgJBZ6w2qQk89oilWKTknLsj5ULpIyA8wJhzFbmB4ITgMTJzp4MoRqupdus7Se
 Z9tOaROek5XXTIyJrQzhVpwGpFMz7Zp+yCH+reXNP7s0p7Xajn35IlMnn7wWjSaKenEk
 empS4scpQyvfNJa4HIeiP6Qt8SP6FLmZP+S+y6ZPJV2A9mmALRRt4d46u6Xg8j6wg8b1
 jkzA==
X-Gm-Message-State: AIVw111sD/1i+qIn89WsiCFMOed+igeAbvnGzBAh4j+966lqtlMAgrLI
 D96rqVgsWOwcBfx89k/Caze/c9GjTA==
X-Received: by 10.202.225.65 with SMTP id y62mr13696661oig.113.1499192414954; 
 Tue, 04 Jul 2017 11:20:14 -0700 (PDT)
MIME-Version: 1.0
References: <wvr4a8jzchll.fsf@HIDDEN>
 <871stj4bj3.fsf@HIDDEN>
In-Reply-To: <871stj4bj3.fsf@HIDDEN>
From: Philipp Stephani <p.stephani2@HIDDEN>
Date: Tue, 04 Jul 2017 18:20:04 +0000
Message-ID: <CAArVCkTFrWWg_YySO=5RnfNjJvDgGs6zA5CBGqnJo0yPURC1Uw@HIDDEN>
Content-Type: multipart/alternative; boundary="001a113d469457eab9055381efdd"
X-Spam-Score: -2.0 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.0 (--)

--001a113d469457eab9055381efdd
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

<npostavs@HIDDEN> schrieb am Mo., 27. M=C3=A4rz 2017 um 05:5=
6 Uhr:

> Philipp Stephani <p.stephani2@HIDDEN> writes:
>
> > As an alternative, if people feel this would require too many
> > parameters, I'd propose reverting the change that adds the documentatio=
n
> > string.  A docstring without arglist is not very useful.  We could also
> > remove the arity parameters and have the C function check the arity
> > itself.
>
> Looking at this a bit closer, I do think this adds too many parameters,
> and in particular, requiring to pass in names for positional parameters
> just makes no sense.  The names are never used (except for displaying
> documentation).
>
> But removing the docstring is not great.  IMO, the right solution here
> is to use a subr-like object instead of a lambda, as suggested in a
> FIXME in emacs-module.c:
>
>   /* FIXME: Use a bytecompiled object, or even better a subr.  */
>
> Then the arity could be checked with `subr-arity' or similar.
>

This is now done (commit 31fded0370c3aa6d2c4370cae21cdb7475873483). This
fixes (1) through (3). (4) through (6) are still open. That's probably OK
if the limitations are documented; modules can always do the equivalent of
(eval '(defun ...)) to get complete support.

--001a113d469457eab9055381efdd
Content-Type: text/html; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><br><br><div class=3D"gmail_quote"><div dir=3D"ltr">&lt;<a=
 href=3D"mailto:npostavs@HIDDEN">npostavs@HIDDEN=
net</a>&gt; schrieb am Mo., 27. M=C3=A4rz 2017 um 05:56=C2=A0Uhr:<br></div>=
<blockquote class=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1p=
x #ccc solid;padding-left:1ex">Philipp Stephani &lt;<a href=3D"mailto:p.ste=
phani2@HIDDEN" target=3D"_blank">p.stephani2@HIDDEN</a>&gt; writes:<b=
r>
<br>
&gt; As an alternative, if people feel this would require too many<br>
&gt; parameters, I&#39;d propose reverting the change that adds the documen=
tation<br>
&gt; string.=C2=A0 A docstring without arglist is not very useful.=C2=A0 We=
 could also<br>
&gt; remove the arity parameters and have the C function check the arity<br=
>
&gt; itself.<br>
<br>
Looking at this a bit closer, I do think this adds too many parameters,<br>
and in particular, requiring to pass in names for positional parameters<br>
just makes no sense.=C2=A0 The names are never used (except for displaying<=
br>
documentation).<br>
<br>
But removing the docstring is not great.=C2=A0 IMO, the right solution here=
<br>
is to use a subr-like object instead of a lambda, as suggested in a<br>
FIXME in emacs-module.c:<br>
<br>
=C2=A0 /* FIXME: Use a bytecompiled object, or even better a subr.=C2=A0 */=
<br>
<br>
Then the arity could be checked with `subr-arity&#39; or similar.<br></bloc=
kquote><div><br></div><div>This is now done (commit 31fded0370c3aa6d2c4370c=
ae21cdb7475873483). This fixes (1) through (3). (4) through (6) are still o=
pen. That&#39;s probably OK if the limitations are documented; modules can =
always do the equivalent of (eval &#39;(defun ...)) to get complete support=
.=C2=A0</div>





</div></div>

--001a113d469457eab9055381efdd--




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#23486: 25.0.93; Modules: features missing from make_function
Resent-From: npostavs@HIDDEN
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Wed, 05 Jul 2017 03:40:02 +0000
Resent-Message-ID: <handler.23486.B23486.149922596330550 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 23486
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: Philipp Stephani <p.stephani2@HIDDEN>
Cc: 23486 <at> debbugs.gnu.org
Received: via spool by 23486-submit <at> debbugs.gnu.org id=B23486.149922596330550
          (code B ref 23486); Wed, 05 Jul 2017 03:40:02 +0000
Received: (at 23486) by debbugs.gnu.org; 5 Jul 2017 03:39:23 +0000
Received: from localhost ([127.0.0.1]:52806 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dSb9v-0007wg-BF
	for submit <at> debbugs.gnu.org; Tue, 04 Jul 2017 23:39:23 -0400
Received: from mail-it0-f54.google.com ([209.85.214.54]:37587)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <npostavs@HIDDEN>) id 1dSb9t-0007wU-Kc
 for 23486 <at> debbugs.gnu.org; Tue, 04 Jul 2017 23:39:21 -0400
Received: by mail-it0-f54.google.com with SMTP id m84so79556222ita.0
 for <23486 <at> debbugs.gnu.org>; Tue, 04 Jul 2017 20:39:21 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=k3jpI8rj+6e664zYe6LAQdRNuueJ8EXzHuA+81PWRCk=;
 b=JsPaclU1sDr78aYGxIBACytR0Jrf3xnNRWflGD4VDFlibRJaYFRH2bfqB/cA3VezFE
 M8Cf5IpHqHbCXaJXVF12Mq0SqU+OV0i+7a7jmaCtuyM3/fr9Vosa+BzVhrCte8piJAw4
 dFQRYOJclnQMk204bsjq1d8ozYpunSRa2SR24Qvc94scm6Bc4jM8iYgXT9aTwUczRDun
 +rA2kf8aLCCzRiUy8ScipULLKwGdrgd+kA3xWBO8FuAlO4Gtr81rQfs/grzrD/grphTY
 gFlc1GyMpnuzW5S/k4AHaOfzXT1bVfvaU+5kfRtkH1g9Xw4EeABqNhLFnijZQGEGoWx3
 YeZA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:from:to:cc:subject:references:date
 :in-reply-to:message-id:user-agent:mime-version;
 bh=k3jpI8rj+6e664zYe6LAQdRNuueJ8EXzHuA+81PWRCk=;
 b=WpqdvrRr35MTxAOFRqkM5OCw0XkM1MZNOdY8xBLgChoPdCWq4//ZjDTf9+6QAur3bD
 RPxMqgWyGPDprEJpwWKxrPDh7j+jla8Ptin3HX2mF49P866dnXguvuD7bygTTCibmIgu
 Dd8FHqItYjwEr7wVa7qrNoKdIyyJ6MH4DV4vDzuLNy9e6UHWKt6OKDxDYUj6VrzlQKf7
 JlOBjQo41siSzT9aAR/bZEJ0T0NGXMiku18X7UuwV9F+xPzDKoHx7AUbXRv27gfYxwBa
 QmHf0e0Gf93R8uC+4M4+KEA+poHSW0Laebmvpsn2dckF1FhpmSIyoDAatA0VRWR5Ikak
 JAxg==
X-Gm-Message-State: AKS2vOyFmc6qY4zZ64PJ2ktOIAovk+ViRp+rsfyPxkqzVAZjgtrTohO+
 SNrHN8P1jEL80mCW
X-Received: by 10.36.88.135 with SMTP id f129mr39232061itb.22.1499225955817;
 Tue, 04 Jul 2017 20:39:15 -0700 (PDT)
Received: from zony ([45.2.7.65])
 by smtp.googlemail.com with ESMTPSA id d23sm10573536ioj.22.2017.07.04.20.39.14
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Tue, 04 Jul 2017 20:39:15 -0700 (PDT)
From: npostavs@HIDDEN
References: <wvr4a8jzchll.fsf@HIDDEN>
 <871stj4bj3.fsf@HIDDEN>
 <CAArVCkTFrWWg_YySO=5RnfNjJvDgGs6zA5CBGqnJo0yPURC1Uw@HIDDEN>
Date: Tue, 04 Jul 2017 23:40:50 -0400
In-Reply-To: <CAArVCkTFrWWg_YySO=5RnfNjJvDgGs6zA5CBGqnJo0yPURC1Uw@HIDDEN>
 (Philipp Stephani's message of "Tue, 04 Jul 2017 18:20:04 +0000")
Message-ID: <87r2xvh7p9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.2.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Philipp Stephani <p.stephani2@HIDDEN> writes:

> This is now done (commit
> 31fded0370c3aa6d2c4370cae21cdb7475873483). This fixes (1) through
> (3). (4) through (6) are still open. That's probably OK if the
> limitations are documented; modules can always do the equivalent of
> (eval ' (defun ...)) to get complete support.

Lisp_Subr's have an intspec field (4), but I agree it's not really
essential.  As I think you mentioned in the OP, supporting `declare' (5)
is not doable by definition (because the effects of 'declare' operate on
the symbol, not the function object).

Docstrings containing null or non-Unicode characters (6) just seems
completely pointless to me.  Are there any cases using that capability
in Emacs (or outside Emacs)?  I would probably consider them as bugs.




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#23486: 25.0.93; Modules: features missing from make_function
Resent-From: Lars Ingebrigtsen <larsi@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sat, 05 Sep 2020 14:00:02 +0000
Resent-Message-ID: <handler.23486.B23486.15993143677768 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 23486
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: 
To: npostavs@HIDDEN
Cc: Philipp Stephani <p.stephani2@HIDDEN>, 23486 <at> debbugs.gnu.org
Received: via spool by 23486-submit <at> debbugs.gnu.org id=B23486.15993143677768
          (code B ref 23486); Sat, 05 Sep 2020 14:00:02 +0000
Received: (at 23486) by debbugs.gnu.org; 5 Sep 2020 13:59:27 +0000
Received: from localhost ([127.0.0.1]:43706 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kEYj1-00021E-Gs
	for submit <at> debbugs.gnu.org; Sat, 05 Sep 2020 09:59:27 -0400
Received: from quimby.gnus.org ([95.216.78.240]:34098)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kEYiz-000210-3B
 for 23486 <at> debbugs.gnu.org; Sat, 05 Sep 2020 09:59:25 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=DTlbv/pgjSRyr2snrHepamaC+9o9Aex1pfVkYlNPcTE=; b=jZQWIMA165TMBgKMVvfRkwe3YM
 OtQgN3ELneLw85GAL1xvTQliBO12Q4l1wpX+XS+NVlkKoqeJgrr/5ztkNia8Y+CO8ewcY4sHzyXQV
 irHPBVyhmfcnec4E9AFnN2Ef2gwU/3k5gxIcLelkxlZNqsKTRhv7DDl+tHMptyQmkfu4=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kEYig-0004SG-54; Sat, 05 Sep 2020 15:59:18 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
References: <wvr4a8jzchll.fsf@HIDDEN>
 <871stj4bj3.fsf@HIDDEN>
 <CAArVCkTFrWWg_YySO=5RnfNjJvDgGs6zA5CBGqnJo0yPURC1Uw@HIDDEN>
 <87r2xvh7p9.fsf@HIDDEN>
X-Now-Playing: RATN's _J_: "=?UTF-8?Q?=E3=82=8F=E3=82=89=E3=81=86=E3=81=A0=E3=81=91?="
Date: Sat, 05 Sep 2020 15:59:04 +0200
In-Reply-To: <87r2xvh7p9.fsf@HIDDEN>
 (npostavs@HIDDEN's message of "Tue, 04 Jul 2017
 23:40:50 -0400")
Message-ID: <87pn70495j.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  npostavs@HIDDEN writes: > Philipp Stephani
 <p.stephani2@HIDDEN> writes: > >> This is now done (commit >>
 31fded0370c3aa6d2c4370cae21cdb7475873483).
 This fixes (1) through >> (3). (4) through (6) are still open. That's pro
 [...] Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

npostavs@HIDDEN writes:

> Philipp Stephani <p.stephani2@HIDDEN> writes:
>
>> This is now done (commit
>> 31fded0370c3aa6d2c4370cae21cdb7475873483). This fixes (1) through
>> (3). (4) through (6) are still open. That's probably OK if the
>> limitations are documented; modules can always do the equivalent of
>> (eval ' (defun ...)) to get complete support.
>
> Lisp_Subr's have an intspec field (4), but I agree it's not really
> essential.  As I think you mentioned in the OP, supporting `declare' (5)
> is not doable by definition (because the effects of 'declare' operate on
> the symbol, not the function object).
>
> Docstrings containing null or non-Unicode characters (6) just seems
> completely pointless to me.  Are there any cases using that capability
> in Emacs (or outside Emacs)?  I would probably consider them as bugs.

This was the final message in this thread.  Philipp's patch fixed the
main problems, and (5) and (6) doesn't sound like something that
can/should be fixed.  Which leaves (4), which didn't seem essential,
either.

So is there more to be done here, or should this bug report be closed?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Message received at control <at> debbugs.gnu.org:


Received: (at control) by debbugs.gnu.org; 5 Sep 2020 13:59:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Sep 05 09:59:32 2020
Received: from localhost ([127.0.0.1]:43709 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kEYj5-00021V-Oe
	for submit <at> debbugs.gnu.org; Sat, 05 Sep 2020 09:59:32 -0400
Received: from quimby.gnus.org ([95.216.78.240]:34114)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kEYj4-000216-2R
 for control <at> debbugs.gnu.org; Sat, 05 Sep 2020 09:59:30 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Subject:From:To:Message-Id:Date:Sender:Reply-To:Cc:
 MIME-Version:Content-Type:Content-Transfer-Encoding:Content-ID:
 Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc
 :Resent-Message-ID:In-Reply-To:References:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=hD5Dr8AD7SPN3uA+i1/hCO9wqoieRb96oT3GhUe1a6Q=; b=WOxuzV9DfALZncQNngnSoru0ob
 fvjIgwEpoNiXYcgM2IMCOKcwXWpLqL4EhNvT4tkz076BPGC77naHavD2OidFNXNPh9BDOBwp7BPjw
 BU0WwOhga0EpY7agtMepfJnd7FPdczpYUggesVv6cOHPGz5ppX9Z93k1TDtia9w5d/zg=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>) id 1kEYiw-0004SS-Ak
 for control <at> debbugs.gnu.org; Sat, 05 Sep 2020 15:59:24 +0200
Date: Sat, 05 Sep 2020 15:59:21 +0200
Message-Id: <87o8mk4952.fsf@HIDDEN>
To: control <at> debbugs.gnu.org
From: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: control message for bug #23486
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  tags 23486 + moreinfo quit 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: control
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

tags 23486 + moreinfo
quit





Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#23486: 25.0.93; Modules: features missing from make_function
Resent-From: Philipp Stephani <p.stephani2@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 13 Sep 2020 09:45:01 +0000
Resent-Message-ID: <handler.23486.B23486.159999027726034 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 23486
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: moreinfo
To: Lars Ingebrigtsen <larsi@HIDDEN>
Cc: 23486 <at> debbugs.gnu.org, Noam Postavsky <npostavs@HIDDEN>
Received: via spool by 23486-submit <at> debbugs.gnu.org id=B23486.159999027726034
          (code B ref 23486); Sun, 13 Sep 2020 09:45:01 +0000
Received: (at 23486) by debbugs.gnu.org; 13 Sep 2020 09:44:37 +0000
Received: from localhost ([127.0.0.1]:49454 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kHOYn-0006lq-2O
	for submit <at> debbugs.gnu.org; Sun, 13 Sep 2020 05:44:37 -0400
Received: from mail-ot1-f46.google.com ([209.85.210.46]:33039)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <p.stephani2@HIDDEN>) id 1kHOYl-0006ld-BV
 for 23486 <at> debbugs.gnu.org; Sun, 13 Sep 2020 05:44:36 -0400
Received: by mail-ot1-f46.google.com with SMTP id m12so12261458otr.0
 for <23486 <at> debbugs.gnu.org>; Sun, 13 Sep 2020 02:44:35 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=P49LohtzX6c7fTT9/35A0em4vvOlfA6OhQh8kigjMsk=;
 b=YoTdZ+KLljLg19zn/ChG/q+JPl4DPN6RuphnS9k96l/hvU61Ce+n6fyRglGnYNWbz0
 t780kk0GzzNFO16Lvke9DCeeC/eEojY97YOTFAm98MhsqN1oF3F3ApeH/kySeOGpMM1d
 4oWq/cq1m5JOGxrsUKT89v7dujw8z2zqvnt2nzzs3AEOUaxdr+rqy+xiKOWtfzHpg86E
 ruPCANM6s1JN5deVMgbuOiHLIT38uguE3gj3rahxSafSGw/yr2Qx4J7UfZddeKe7ndWm
 aA9DJ7WTnupI82UH7tZ5cMnUA0UG5Ib1XcbPNKPBL9GXf0ZMVMSotdsmIJ54YPgceORF
 Ybow==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=P49LohtzX6c7fTT9/35A0em4vvOlfA6OhQh8kigjMsk=;
 b=fpMeaZ+e6nM35O4yVME8dyD28RYdgXN9qy23CQXTkaM8tNKpfE4KlmmX4iNtc6SGLq
 TLTQNswj75u7D/K1R66cGw251kOZ5UST6i/rZhogP1YPh7V+psqDNxTiYREnvJDoJCuo
 PeM1/d9M9T3F9sTolAn6z7q/RZryTRxM/jJJbR1WYIz5wN/4cIf4zD784+NuEHPMUmhH
 0o1LyR8gZ7/5w3EWvsz9Z0NEjuQqSbOtsBAhgqlKJKJk+DaEBhO+Yl3Y70J9ZW88AYup
 RCDslw3fJ4PfAT3LonQ38MPSEyo7uClNF/l+ZD72/3c1uLgBBUh9uYcEb3TQy3P1c9h6
 qTLg==
X-Gm-Message-State: AOAM5308EuUpwcfDozApQW6XG7+Qof+ju1VKqdLvUFVr6nPShYn0gX0L
 rxSXfpIJBI+qM120Lmhq8e7Qf3wOKnKlC9lCMEA=
X-Google-Smtp-Source: ABdhPJzD1eLL3nxsaWupqtT/K/8qKCE6041GWJmz7x0QAwBLgcCOWzYuQjEXbzvxze5qTy8oZp9IhpD7T07Y/15SGrs=
X-Received: by 2002:a9d:20c1:: with SMTP id x59mr6007812ota.36.1599990269378; 
 Sun, 13 Sep 2020 02:44:29 -0700 (PDT)
MIME-Version: 1.0
References: <wvr4a8jzchll.fsf@HIDDEN>
 <871stj4bj3.fsf@HIDDEN>
 <CAArVCkTFrWWg_YySO=5RnfNjJvDgGs6zA5CBGqnJo0yPURC1Uw@HIDDEN>
 <87r2xvh7p9.fsf@HIDDEN> <87pn70495j.fsf@HIDDEN>
In-Reply-To: <87pn70495j.fsf@HIDDEN>
From: Philipp Stephani <p.stephani2@HIDDEN>
Date: Sun, 13 Sep 2020 11:44:18 +0200
Message-ID: <CAArVCkQvj_oQypK9hVJWmhx7-vT5bmHXgFDMCf+ZUKedz3bGJg@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.3 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Am Sa., 5. Sept. 2020 um 15:59 Uhr schrieb Lars Ingebrigtsen <larsi@HIDDEN>:
>
> npostavs@HIDDEN writes:
>
> > Philipp Stephani <p.stephani2@HIDDEN> writes:
> >
> >> This is now done (commit
> >> 31fded0370c3aa6d2c4370cae21cdb7475873483). This fixes (1) through
> >> (3). (4) through (6) are still open. That's probably OK if the
> >> limitations are documented; modules can always do the equivalent of
> >> (eval ' (defun ...)) to get complete support.
> >
> > Lisp_Subr's have an intspec field (4), but I agree it's not really
> > essential.  As I think you mentioned in the OP, supporting `declare' (5)
> > is not doable by definition (because the effects of 'declare' operate on
> > the symbol, not the function object).
> >
> > Docstrings containing null or non-Unicode characters (6) just seems
> > completely pointless to me.  Are there any cases using that capability
> > in Emacs (or outside Emacs)?  I would probably consider them as bugs.
>
> This was the final message in this thread.  Philipp's patch fixed the
> main problems, and (5) and (6) doesn't sound like something that
> can/should be fixed.  Which leaves (4), which didn't seem essential,
> either.
>
> So is there more to be done here, or should this bug report be closed?
>

I'd still like to fix (4), just for completeness's sake. How about
introducing {get,set}_interactive_spec, just like
{get,set}_function_finalizer?




Message sent to bug-gnu-emacs@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#23486: 25.0.93; Modules: features missing from make_function
Resent-From: Lars Ingebrigtsen <larsi@HIDDEN>
Original-Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 13 Sep 2020 13:21:02 +0000
Resent-Message-ID: <handler.23486.B23486.160000325515398 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 23486
X-GNU-PR-Package: emacs
X-GNU-PR-Keywords: moreinfo
To: Philipp Stephani <p.stephani2@HIDDEN>
Cc: 23486 <at> debbugs.gnu.org, Noam Postavsky <npostavs@HIDDEN>
Received: via spool by 23486-submit <at> debbugs.gnu.org id=B23486.160000325515398
          (code B ref 23486); Sun, 13 Sep 2020 13:21:02 +0000
Received: (at 23486) by debbugs.gnu.org; 13 Sep 2020 13:20:55 +0000
Received: from localhost ([127.0.0.1]:49723 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kHRw6-00040I-VT
	for submit <at> debbugs.gnu.org; Sun, 13 Sep 2020 09:20:55 -0400
Received: from quimby.gnus.org ([95.216.78.240]:44768)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kHRw4-000403-V5
 for 23486 <at> debbugs.gnu.org; Sun, 13 Sep 2020 09:20:53 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=L9TyLkl6b5kuOKxcNGpt2jZOG8rll59Nqd3dGpyIsGg=; b=ROOwopy7bvxZZH+HMhITuw13JD
 YS5nFrdpR72Cbi9A1PVAZOXSIN/VGYPa2sIALnWXuBVNHW6j1rHSvdeqVbKsB+egHKjvB2pjH75dK
 sKanBYRk8YXSfRmDfL5a5YbdgZSwsBAs1vanXy4Oay6PfE03vbONnOWUkIiZkcz0ljlQ=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kHRvw-0003HA-8E; Sun, 13 Sep 2020 15:20:46 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
References: <wvr4a8jzchll.fsf@HIDDEN>
 <871stj4bj3.fsf@HIDDEN>
 <CAArVCkTFrWWg_YySO=5RnfNjJvDgGs6zA5CBGqnJo0yPURC1Uw@HIDDEN>
 <87r2xvh7p9.fsf@HIDDEN> <87pn70495j.fsf@HIDDEN>
 <CAArVCkQvj_oQypK9hVJWmhx7-vT5bmHXgFDMCf+ZUKedz3bGJg@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAGFBMVEX+98P98rrk0qTB
 royThnBhWFA9Nzb///+OKkWvAAAAAWJLR0QHFmGI6wAAAAd0SU1FB+QJDQ0UFfXQ6XUAAAFnSURB
 VDjLrZPhcYQgEIVBrwAwDcS9KyABbeAEG9ClAqH/ErKAGjTnj5vJGx1m+HjwWIAxkiSxV+LsQhfj
 3xeXWbEVkgkhOBP7Ihe5LmOxBkgSgNrPA/jQWt1BK3iqrwOoWmhBtiAAxGmyCgiduzklpLhlzqyz
 ezdUSg1wh03bOM7rQQ9KU5eiX+t9Al4rMMmh9WN6FIASGeh6NBbR4/ILGq1Nh2NwdiLgC0fX2dG7
 gP2A3pQOAi64EPrJBbM7uGy6PgNLwJag38BwciRAsnMIcxBrOTivejsm4ObgsAB1Nng3LsEXQNbW
 RIBoPbl8AdDQDH62XTJugPEbzoi46F4TwALUSEVyi4rA24ODShRiDWdXAC5vAdPaDn3I1RU57i3u
 IYEYQe1AZkD7iAttR7sCt7JvuouCF2DVMx58vPLrBj1mTQ3czbwCsb2PQkwK+l4AkdjbQF4CivXn
 OiewJTn0F+Co5v8A+wG7BX0o0W8aNAAAACV0RVh0ZGF0ZTpjcmVhdGUAMjAyMC0wOS0xM1QxMzoy
 MDoyMSswMDowMOBKvC4AAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjAtMDktMTNUMTM6MjA6MjErMDA6
 MDCRFwSSAAAAAElFTkSuQmCC
X-Now-Playing: Paula Frazer and Tarnation's _What Is And Was_: "What Is And
 Was"
Date: Sun, 13 Sep 2020 15:20:43 +0200
In-Reply-To: <CAArVCkQvj_oQypK9hVJWmhx7-vT5bmHXgFDMCf+ZUKedz3bGJg@HIDDEN>
 (Philipp Stephani's message of "Sun, 13 Sep 2020 11:44:18 +0200")
Message-ID: <87o8m9yfro.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Philipp Stephani <p.stephani2@HIDDEN> writes: > I'd still
 like to fix (4), just for completeness's sake. How about > introducing {get,
 set}_interactive_spec, 
 just like > {get,set}_function_finalizer? 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Philipp Stephani <p.stephani2@HIDDEN> writes:

> I'd still like to fix (4), just for completeness's sake. How about
> introducing {get,set}_interactive_spec, just like
> {get,set}_function_finalizer?

Sure, sounds logical to me.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Last modified: Sun, 13 Sep 2020 13:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.